unit Libro;

  {Esta unidad contiene los procedimientos y funciones necesarios para
   mostrar por pantalla los datos de uno o de todos los libros.}

interface

const

MaxLibros = 50;

  {Cantidad maxima de libros.}

{********************************************************************}

type

Estados = (Disponible, Prestado, Deposito);

  {Las distintas situaciones de un libro.}

RegistroDeLibros = record
                     signatura: string[10];
                     titulo: string[40];
                     autor: string[40];
                     edicion: integer;
                     situacion: Estados;
                   end;

  {Ficha para cada libro, tal y como se pide en el enunciado.}

ArrayDeLibros = Array[1..MaxLibros] of RegistroDeLibros;

  {Array con los registros de libros.}

BBDDLibros = record
               Limite: 0..MaxLibros;
               Elemento: ArrayDeLibros
             end;

  {Registro con la lista variable}

{********************************************************************}

procedure MostrarLibro(Lib: BBDDLibros);

  {Este procedimiento mostrara UN libro por pantalla.}

procedure MostrarLibros(Lib: BBDDLibros);

  {Este procedimiento mostrara TODOS los libros por pantalla.}

{********************************************************************}

implementation

procedure Mostrar(Lib: BBDDLibros; i: integer);

  {En realidad, los dos procedimientos se resumen en este solo. Recibe
   la BBDD y el libro a mostrar, y escribe sus datos.}

begin
  with Lib.Elemento[i] do
    begin
      write('Titulo: ');
      writeln(titulo);
      write('Autor: ');
      writeln(autor);
      write('Edicion: ');
      writeln(edicion);
      write('Signatura: ');
      writeln(signatura);
      write('Estado: ');
      case situacion of
        Disponible: writeln('DISPONIBLE');
        Prestado: writeln('PRESTADO');
        Deposito: writeln('DEPOSITO');
      end;
      writeln;
    end
end;

{********************************************************************}

procedure MostrarLibro(Lib: BBDDLibros);

  {Este procedimiento pide al usuario el numero del libro a mostrar, y lo
   manda al procedimiento mostrar. Para ello solo usa la BBDD.}

var
  sig: string;

  {Signatura del libro a mostrar.}

  i, j: integer;

  {I es una variable de recorrido y j la variable que almacena la coordenada
   del libro a mostrar.}

  fallo: boolean;

  {Variable de control.}

begin
  j := 0;
  fallo := false;
  writeln;
  write('Signatura del libro a mostrar: ');
  readln(sig);
  for i := 1 to Lib.Limite do
    begin
      if Lib.Elemento[i].signatura = sig then
        j := i;
      if (i = Lib.limite) and (j = 0) then
        fallo := true;
    end;
  if not fallo then
    begin
      Mostrar(Lib, j);
      writeln('Fin de ficha.');
    end
  else
    begin
      writeln('El libro no existe');
    end;
  readln;

end;

{********************************************************************}

procedure MostrarLibros(Lib: BBDDLibros);

  {Este procedimiento es un llamamiento sucesivo al procedimiento mostrar,
   para, mediante un for, ensear todos los libros disponibles. Para ello
   necesita la BBDD.}

var
  i: integer;

  {Variable de recorrido.}

begin
  if Lib.Limite = 0 then
    begin
      writeln('No hay libros dados de alta.');
    end
  else
    begin
      for i := 1 to Lib.Limite do
        begin
          Mostrar(Lib, i);
          if (i mod 6) = 0 then
            readln;
        end;
     writeln('Fin de fichero.');
    end;
  readln;
end;

{********************************************************************}

end.