{#############################
 #                           #
 # Practica 4: Libreria G49  #
 #                           #
 # Alejandro Dobeson Beirao  #
 #                           #
 #############################}

program Libreria;

  {Este programa pretende servir para la administracion de cualquier
   biblioteca de tamao pequeo-medio, con funciones para el prestamo
   devolucion y recuento de libros, recuento de socios y un informe de
   la cantidad de libros y socios dados de alta.}

uses crt, dos, Llibro, Lsocio, Libro, Socio;

  {Para ello, usaremos la libreria CRT, para limpiar la pantalla, DOS,
   para obtener la fecha y hora del sistema, y las unidades propias con
   las funciones de dada de alta, dada de baja y mostrar datos.}

{********************************************************************}

var

NombreLibro: string;
NombreSocio: string;

  {Estas dos variables nos serviran para obtener y guardar los nombres
   de los ficheros en los que guardaremos los datos para libros y socios,
   respectivamente}

Libros: BBDDLibros;
Socios: BBDDSocios;

  {Las bases de datos en s, definidas en tipo en la unidad Llibro y
   Lsocio.}

opcion: integer;

  {Una variable para el men.}

{********************************************************************}

procedure NombreArchivos(var NombreLib, NombreSoc: string;
                         var Lib: BBDDLibros;
                         var Soc: BBDDSocios);

  {Este procedimiento es el que inicia todo. Pide los datos para la
   lectura, o creacion en caso de que no exista, de la base de datos.
   Primero pide para los libros, despues, para los socios. Devuelve
   los nombres de los archivos, para uso en los procedimientos de
   guardado, y las BBDD en s.}

var
  ArchLib: ArchivoLibros;
  ArchSoc: ArchivoSocios;
  aux: char;
  fallo: boolean;

  {De forma local, usaremos dos variables de tipo Archivo, definidas en
   las unidades L, una auxiliar para dar a elegir al usuario entre
   corregir el nombre de archivo introducido o crear un archivo nuevo, y
   una variable de control.}

begin
  repeat
    CrearBBDDLibros(Lib);
    fallo := true;
    write('Nombre del fichero de libros: ');
    readln(NombreLib);
    assign(ArchLib, NombreLib);
    {$I-}
    reset(ArchLib);
    {$I+}

    if IOResult = 0 then
      begin
        fallo := false;
      end
    else
      begin
        writeln;
        write('Fichero de libros no encontrado. Desea crearlo? (S/N) ');
        readln(aux);
        writeln;
        case aux of
          's', 'S': {$I-}
                    rewrite(ArchLib);
                    {$I+}

        end;
      end
  until (IOResult = 0) and (fallo = false);

  reset(ArchLib);
  while not eof(ArchLib) do
    read(ArchLib, Lib);
  close(ArchLib);

  repeat
    fallo := true;
    CrearBBDDSocios(Soc);
    write('Nombre del fichero de socios: ');
    readln(NombreSoc);
    assign(ArchSoc, NombreSoc);
    {$I-}
    reset(ArchSoc);
    {$I+}

    if IOResult = 0 then
      begin
        fallo := false;
      end
    else
      begin
        writeln;
        write('Fichero de socios no encontrado. Desea crearlo? (S/N) ');
        readln(aux);
        writeln;
        case aux of
          's', 'S': {$I-}
                    rewrite(ArchSoc);
                    {$I+}
        end;
      end
  until (IOResult = 0) and (fallo = false);

  reset(ArchSoc);
  while not eof(ArchSoc) do
    read(ArchSoc, Soc);
  close(ArchSoc);
end;

{********************************************************************}

procedure PrestarLibro(var Lib: BBDDLibros; var Soc: BBDDSocios);

  {Este es el procedimiento que presta libros a los socios, siempre y
   cuando el libro y socio existan, el socio no tenga ya 3 libros
   prestados, y el libro en cuestion este disponible, y no en deposito
   o prestado. Devuelve y modifica las dos BBDD}

  {********************************************************************}

  function VerificaFecha(dia, mes, anyo: integer): boolean;

    {Esta funcion es un "prestamo" de una practica anterior. Con este
     verificador, comprobaremos que la fecha que se introduce para la
     devolucion puede tener lugar.}

  var
    diasmes: integer;
    aux: boolean;

    {Diasmes es autoexplicativa, y aux es una variable que controla si
     el ao en cuestion es bisiesto, o no.}

  begin
    aux := ((Anyo Mod 4 = 0) AND (Anyo Mod 100 <> 0)) OR
            (Anyo Mod 400 = 0);
    case mes of
      1, 3, 5, 7, 8, 10, 12: Diasmes := 31;
      4, 6, 9, 11: Diasmes := 30;
      2: begin
           case aux of
            true: DiasMes := 29;
            false: DiasMes := 28;
           end;
         end
      end;
    VerificaFecha := (dia <= diasmes)

  end;

  {******************************************************************}

var
  car, libsig, soccar, i: integer;

  {Car: Valor del carnet que introduce el usuario. LibSig: Coordenada
   del array en el que la signatura introducida (sig) y la del array
   coinciden. Soccar: Coordenada del array en el que el carnet introducido
   y el del array coinciden. I es una variable auxiliar para recorridos.}

  fallo: boolean;

  {Variable de control.}

  sig: string;

  {Signatura del libro que introduce el usuario.}

begin
  if Soc.Limite = 0 then
    begin
      writeln('No hay socios en la base de datos.');
      readln;
    end
  else
    begin
      fallo := false;
      soccar := 0;
      libsig := 0;
      write('Carnet de socio: ');
      readln(car);
      for i := 1 to Soc.Limite do
        begin
          if car = Soc.Elemento[i].carnet then
               soccar := i;
          if (i = Soc.Limite) and (soccar = 0) then
            fallo := true;
        end;

      if fallo = true then
        begin
          writeln('El socio indicado no esta dado de alta.');
          readln;
        end
      else
        begin
          fallo := false;
          if Soc.elemento[soccar].prestados.limite < 3 then
            begin
              write('Signatura del libro: ');
              readln(sig);
              while libsig = 0 do
                for i := 1 to Lib.Limite do
                  begin
                    if sig = Lib.Elemento[i].signatura then
                      libsig := i;
                    if (i = Lib.Limite) and (libsig = 0) then
                      begin
                        fallo := true;
                        libsig := i;
                      end
                  end;
              if fallo = true then
                begin
                  writeln('El libro indicado no esta dado de alta.');
                  readln;
                end
              else
                begin
                  if Lib.Elemento[LibSig].Situacion = Disponible then
                    begin
                      Lib.Elemento[LibSig].Situacion := Prestado;
                      with Soc.Elemento[soccar].Prestados do
                        begin
                          Limite := Limite + 1;
                          elemento[limite].signatura := sig;
                          with elemento[limite].devolucion do
                            begin
                              repeat
                                repeat
                                  write('A devolver el dia: ');
                                  readln(dia);
                                until (dia > 0) and
                                      (dia < 32);
                                repeat
                                  write('Del mes: ');
                                  readln(mes);
                                until (mes > 0) and
                                      (mes < 13);
                                repeat
                                  write('Del ao: ');
                                  readln(elemento[limite].devolucion.anyo);
                                until (anyo > 0)
                              until VerificaFecha(dia, mes, anyo) = true;
                            end;
                          writeln('Prestamo hecho.');
                          readln;
                          GuardarLibros(Libros, NombreLibro);
                          GuardarSocios(Socios, NombreSocio);
                        end
                    end
                  else
                    begin
                      writeln('El libro no esta disponible para prestamo.');
                      readln;
                    end
                end
            end
          else
            begin
              writeln;
              writeln('El socio ya ha alcanzado su limite de prestamos.');
              readln;
            end
        end
    end
end;

{********************************************************************}

procedure DevolverLibro(var Lib: BBDDLibros; var Soc: BBDDSocios);

  {Este procedimiento devolvera los libros. Pide el numero de carnet y
   muestra una lista coloreada de los libros prestados. En rojo los
   atrasados, blancos los que venzan el mismo dia, y grises los que
   se devuelvan del dia siguiente en adelante. Devuelve las dos BBDD.}

var
  sig: string;

  {Signatura del libro introducido por el usuario}

  i, j, coordenada, car: integer;

  {I y j son variables de recorrido, coordenada guardara la coordenada del
   array de libros prestados que corresponde al libro a devolver. Car es
   el carnet que introduce el usuario.}

  anyo, mes, dia, a: word;

  {Estas variables son autoexplicativas. Como no me interesaba usar el dia
   de la semana, defini una variable que guardara ese dato, y no hara nada
   mas.}

  hallado, fallo: boolean;

  {Dos variables de control para diversos mensajes de error.}

begin
  if Soc.Limite = 0 then
    begin
      writeln('No hay socios en la base de datos.');
      readln;
    end
  else
    begin
      hallado := false;
      fallo := true;
      writeln;
      write('Numero de carnet: ');
      readln(car);
      for i := 1 to Soc.Limite do
        if (Soc.Elemento[i].carnet = car) and
           (Soc.Elemento[i].Prestados.Limite > 0) then
          begin
            with Soc.Elemento[i].prestados do
              begin
                fallo := false;
                writeln('PRESTADOS');
                writeln('*********');
                for j := 1 to Limite do
                  begin
                    getdate(anyo, mes, dia, a);
                    with elemento[j] do
                      begin
                        if ((devolucion.dia < dia) and
                           (devolucion.mes = mes) and
                           (devolucion.anyo = anyo)) or
                           ((devolucion.mes < mes) and
                           (devolucion.anyo = anyo)) or
                           (devolucion.anyo < anyo) then
                          begin
                            textcolor(lightred+blink);
                            write(signatura);
                            normvideo;
                            writeln(' ', devolucion.dia, '/',
                                   devolucion.mes, '/',
                                   devolucion.anyo, ' (CADUCADO)');
                          end;
                        if ((devolucion.dia = dia) and
                           (devolucion.mes = mes) and
                           (devolucion.anyo = anyo)) then
                          begin
                            textcolor(white);
                            write(elemento[j].signatura);
                            normvideo;
                            writeln(' ', devolucion.dia, '/',
                                   devolucion.mes, '/',
                                   devolucion.anyo, ' (FECHA LIMITE)');
                          end;
                        if ((devolucion.dia > dia) and
                           (devolucion.mes = mes) and
                           (devolucion.anyo = anyo)) or
                           ((devolucion.mes > mes) and
                           (devolucion.anyo = anyo)) or
                           (devolucion.anyo > anyo) then
                          writeln(signatura, ' ',
                                  devolucion.dia, '/',
                                  devolucion.mes, '/',
                                  devolucion.anyo);
                      end
                  end;
                writeln;
                repeat
                  write('Cual desea devolver? ');
                  readln(sig);
                  for j := 1 to Limite do
                    if elemento[j].signatura = sig then
                      begin
                        coordenada := j;
                        hallado := true;
                      end;
                  if (hallado = false) then
                    writeln('Libro no prestado.');
                until hallado = true;
                for j := coordenada to Limite do
                  elemento[j] := elemento[j + 1];
                Limite := Limite - 1;
                GuardarSocios(Socios, NombreSocio);
                with lib do
                  for j := 1 to Limite do
                    if Elemento[j].signatura = sig then
                      begin
                        Elemento[j].situacion := Disponible;
                        GuardarLibros(Libros, NombreLibro);
                      end;
                writeln('Devolucion correcta.');
                readln;
              end
          end;
      if (fallo = true) then
        begin
          writeln('El socio especificado no tiene libros a devolver o no existe.');
          readln;
        end
    end
end;

{********************************************************************}

procedure InformeDia(Lib: BBDDLibros; Soc: BBDDSocios);

  {Pide al usuario un nombre de archivo, y escribe un informe del dia,
   que contiene la hora, la fecha, la cantidad de libros dados de alta,
   la cantidad de socios dados de alta, y los carnets de los morosos.
   Si se debe mas de un libro, entonces se escribira en el informe
   su carnet tantas veces como libros deba. Lo escribe en pantalla
   aparte de en el fichero. De caso de dar como nombre un archivo ya
   existente, el informe se escribe al final del fichero, sin reescribirlo.}

var
  NombreInf: string;

  {Nombre del archivo del informe}

  Informe: text;

  {Archivo de texto}

  aux: char;

  {Para dar a elegir al usuario entre crear archivo nuevo o cambiar
   el nombre introducido}

  anyo, mes, dia, hora, minuto, a: word;

  {Variables autoexplicativas, a sigue siendo una variable para lo
   que no interesa de los procedimientos}

  i, j: integer;

  {I y J son variables de recorrido}

  fallo, morosos: boolean;

  {Variables de control. Morosos servira para saber que escribir por
   pantalla, o si se debe escribir una coma o no antes del siguiente
   carnet.}

begin
  repeat
    fallo := false;
    write('Nombre del fichero: ');
    readln(NombreInf);
    assign(Informe, NombreInf);
    {$I-}
    reset(Informe);
    {$I+}

    if IOResult <> 0 then
      begin
        writeln;
        write('Fichero no encontrado. Desea crearlo? (S/N) ');
        readln(aux);
        writeln;
        case aux of
          's', 'S': begin
                      {$I-}
                      rewrite(Informe);
                      {$I+}
                      fallo := true;
                    end
        end;
      end
  until (IOResult = 0) and (fallo = false);

  morosos := false;
  getdate(anyo, mes, dia, a);
  gettime(hora, minuto, a, a);
  append(Informe);
  writeln(hora, ':', minuto, ' ', dia, '/', mes, '/', anyo, ':');
  writeln('LIBROS: ', Lib.Limite);
  writeln('SOCIOS: ', Soc.Limite);
  write('MOROSOS: ');
  writeln(Informe, hora, ':', minuto, ' ', dia, '/', mes, '/', anyo, ':');
  writeln(Informe, 'LIBROS: ', Lib.Limite);
  writeln(Informe, 'SOCIOS: ', Soc.Limite);
  write(Informe, 'MOROSOS: ');
  for i := 1 to Soc.Limite do
    for j := 1 to Soc.Elemento[i].Prestados.Limite do
      if ((Soc.Elemento[i].Prestados.Elemento[j].Devolucion.dia < dia) and
         (Soc.Elemento[i].Prestados.Elemento[j].Devolucion.mes = mes)) or
         (Soc.Elemento[i].Prestados.Elemento[j].Devolucion.mes < mes) then
        begin
          if morosos = true then
            begin
              write(', ', Soc.Elemento[i].Carnet);
              write(Informe, ', ', Soc.Elemento[i].Carnet);
            end
          else
            begin
              write(Soc.Elemento[i].Carnet);
              write(Informe, Soc.Elemento[i].Carnet);
              morosos := true;
            end;
        end;
  if morosos = false then
    begin
      write('Ninguno');
      write(Informe, 'Ninguno');
    end;
  writeln;
  writeln;
  writeln(Informe);
  writeln(Informe);
  close(Informe);
  writeln('Archivo creado');
  readln;

end;

{********************************************************************}

procedure DibujaInterfaz;

  {Este sencillo procedimiento dibujara una interfaz alrededor de la
   pantalla con codigo ASCII.}

var
  i, j: integer;

  {Variables de recorrido}

begin
  write('');
  for i := 1 to 78 do
    write('');
  write('');
  gotoxy(35, 2);
  write('Biblioteca');
  gotoxy(80, 2);
  write('');
  for i := 1 to 78 do
    write('');
  write('');
  for j := 4 to 48 do
    begin
      write('');
      gotoxy(80, j);
      write('');
    end;
  write('');
  for i := 1 to 78 do
    write('');
  write('');
end;

{********************************************************************}

procedure EscribeMenu(var op: integer);

  {Este procedimiento muestra por pantalla el menu e interpreta las
   opciones. Como novedad, destacaria el uso del readkey en vez de
   readln. Tiene un comprobador de entrada, de forma que solo deberia
   reaccionar a las opciones reales del programa. Devuelve la opcion final.}

var
  op2, op3: char;

  {Variables para moverse entre los menus.}

begin
  op := 50;
  repeat
    clrscr;
    writeln('1. Funciones de prestamo y devolucion.');
    writeln('2. Funciones de libros.');
    writeln('3. Funciones de socios.');
    writeln('4. Realizar informe del dia.');
    writeln('5. Cambio de fuente de datos.');
    writeln;
    writeln('0. Salir.');
    repeat
      op2 := readkey;
    until ((op2 = '1') or (op2 = '2') or (op2 = '3') or (op2 = '4') or
           (op2 = '5') or (op2 = '0'));
    clrscr;
    case op2 of
      '1': begin
             writeln('1. Prestar un libro.');
             writeln('2. Devolver un libro.');
             writeln;
             writeln('0. Volver al men anterior.');
             repeat
               op3 := readkey;
             until ((op3 = '1') or (op3 = '2') or (op3 = '0'));
             case op3 of
               '1': begin
                      op := 1;
                    end;
               '2': begin
                      op := 2;
                    end;
               '0': begin
                      op := 0;
                    end;
             end;
           end;
      '2': begin
             writeln('1. Mostrar los datos de un libro.');
             writeln('2. Mostrar los datos de todos los libros.');
             writeln('3. Insertar un nuevo libro.');
             writeln('4. Eliminar un libro ya existente.');
             writeln;
             writeln('0. Volver al men anterior.');
             repeat
               op3 := readkey;
             until ((op3 = '1') or (op3 = '2') or (op3 = '3') or
                    (op3 = '4') or (op3 = '0'));
             case op3 of
               '1': begin
                      op := 7;
                    end;
               '2': begin
                      op := 8;
                    end;
               '3': begin
                      op := 3;
                    end;
               '4': begin
                      op := 4;
                    end;
               '0': begin
                      op := 0;
                    end;
             end;
           end;
      '3': begin
             writeln('1. Mostrar los datos de un socio.');
             writeln('2. Mostrar los datos de todos los socios.');
             writeln('3. Insertar un nuevo socio.');
             writeln('4. Eliminar un socio ya existente.');
             writeln;
             writeln('0. Volver al men anterior');
             repeat
               op3 := readkey;
             until ((op3 = '1') or (op3 = '2') or (op3 = '3') or
                    (op3 = '4') or (op3 = '0'));
             case op3 of
               '1': begin
                      op := 9;
                    end;
               '2': begin
                      op := 10;
                    end;
               '3': begin
                      op := 5;
                    end;
               '4': begin
                      op := 6;
                    end;
               '0': begin
                      op := 0;
                    end;
             end;
           end;
      '4': op := 11;
      '5': op := 12;
      '0': op := 0;
    end;
  until ((op > 0) and (op < 13)) or (op2 = '0');
end;

{********************************************************************}

procedure CambioFuente(var NombreLib, NombreSoc: string;
                       Lib: BBDDLibros;
                       Soc: BBDDSocios);

  {Este es el procedimiento que controla el cambio de fuente de datos.
   Mediante un case, se da a elegir al usuario entre guardar en un
   archivo todos los datos cargados en memoria, o abrir unos nuevos.
   El codigo de la segunda opcion es simplemente un llamamiento a la
   funcion inicial. La primera opcion crea los archivos sobreescribiendo
   lo que pudiera haber antes en ellos. Necesita las BBDD y devuelve
   los nuevos nombres para los archivos de datos.}

var
  aux: char;

  {Como en el resto, esta variable da a elegir entre las dos opciones}

  archlib: archivolibros;
  archsoc: archivosocios;

  {variables para los archivos}

begin
  writeln('(G)uardar los datos actuales en otro fichero o (c)argar nuevos?');
  aux := readkey;
  case aux of
  'g', 'G': begin
              repeat
                write('Nombre del fichero de libros: ');
                readln(NombreLib);
                assign(ArchLib, NombreLib);
                {$I-}
                rewrite(ArchLib);
                {$I+}
              until IOResult = 0;
              write(ArchLib, Lib);
              close(ArchLib);

              repeat
                write('Nombre del fichero de socios: ');
                readln(NombreSoc);
                assign(ArchSoc, NombreSoc);
                {$I-}
                rewrite(ArchSoc);
                {$I+}
              until IOResult = 0;
              write(ArchSoc, Soc);
              close(ArchSoc);
              writeln;
              writeln('Archivos nuevos guardados con exito.');
              readln;
            end;
  'c', 'C': begin
              writeln;
              textcolor(white+blink);
              write('Precaucion');
              normvideo;
              writeln(': Seleccione archivos que tengan relacion entre s, a fin de que');
              write('            no se produzcan errores, fallos o relaciones improcedentes');
              textcolor(white+blink);
              writeln(' !!!');
              writeln;
              normvideo;
              NombreArchivos(NombreLib, NombreSoc, Lib, Soc);
              writeln;
              writeln('Archivos cargados o creados con exito.');
              readln;
            end
  end;
  if (aux <> 'g') and (aux <> 'G') and (aux <> 'c') and (aux <> 'C') then
    begin
      writeln('La opcion no es valida.');
      readln;
    end
end;
{********************************************************************}

begin
  textmode(co80 or font8x8);
  clrscr;
  NombreArchivos(NombreLibro, NombreSocio, Libros, Socios);
  clrscr;
  DibujaInterfaz;
  window(3, 5, 78, 45);
  repeat
    EscribeMenu(opcion);
    clrscr;
    case opcion of
      1: PrestarLibro(Libros, Socios);
      2: DevolverLibro(Libros, Socios);
      3: InsertarLibros(NombreLibro, Libros);
      4: EliminarLibros(NombreLibro, Libros);
      5: InsertarSocios(NombreSocio, Socios);
      6: EliminarSocios(NombreSocio, Socios);
      7: MostrarLibro(Libros);
      8: MostrarLibros(Libros);
      9: MostrarSocio(Socios);
      10: MostrarSocios(Socios);
      11: InformeDia(Libros, Socios);
      12: CambioFuente(NombreLibro, NombreSocio, Libros, Socios);
    end
  until (opcion = 0);
end.
