unit Socio;

  {Esta unidad contiene los procedimientos y funciones necesarios para
   mostrar por pantalla los datos de uno o de todos los socios.}

interface

uses dos, crt;

  {Usa la unidad DOS para obtener la fecha del sistema y CRT para
   colorear los libros caducados.}

{********************************************************************}

const

MaxSocios = 10;

  {Constante definida por el enunciado, S.}

{********************************************************************}

type

RegistroFecha = record
                  dia: integer;
                  mes: integer;
                  anyo: integer
                end;

  {Registro que contiene la fecha de devolucion de cada libro.}

RegistroDeLibrosPrestados = record
                              signatura: string[10];
                              devolucion: registrofecha
                            end;

  {Registro para los libros prestados, compuesto por su nombre y fecha.}

ArrayLibrosPrestados = Array[1..3] of RegistroDeLibrosPrestados;

  {Array de registros de libros prestados.}

LibrosPrestados = record
                    limite: 0..3;
                    elemento: ArrayLibrosPrestados
                  end;

  {Lista variable de libros prestados.}

RegistroDeSocios = record
                     nombre: string[40];
                     carnet: integer;
                     prestados: LibrosPrestados;
                   end;

  {Registro de socios, con su nombre, numero de carnet, y libros prestados.}

ArrayDeSocios = Array [1..MaxSocios] of RegistroDeSocios;

  {Array de registros de socios.}

BBDDSocios = record
               Limite: 0..MaxSocios;
               Elemento: ArrayDeSocios
             end;

  {Lista variable de socios.}

{********************************************************************}

procedure MostrarSocio(Soc: BBDDSocios);

  {Este procedimiento mostrara UN socio por pantalla.}

procedure MostrarSocios(Soc: BBDDSocios);

  {Este procedimiento mostrara TODOS los socios por pantalla.}

{********************************************************************}

implementation

procedure Mostrar(Soc: BBDDSocios; i: integer);

  {En realidad, los dos procedimientos se resumen en este solo. Recibe
   la BBDD y el socio a mostrar, y escribe sus datos. Tambien comprueba
   si se deben libros.}

var
  j: integer;

  {Variable de recorrido}
 
  anyo, mes, dia, a: word;

  {Variables para la fecha.}

  Mas: boolean;

  {Variable para saber si poner o no coma en la pantalla.}

begin
  with Soc.Elemento[i] do
    begin
      getdate(anyo, mes, dia, a);
      write('Nombre: ');
      writeln(nombre);
      write('Carnet: ');
      writeln(carnet);
      write('Prestados: ');
      writeln(Prestados.Limite);
      if Prestados.Limite > 0 then
        begin
          mas := false;
          write('Libros prestados: ');
          for j := 1 to Prestados.Limite do
            with Prestados.Elemento[j] do
              begin
                if ((dia > devolucion.dia) and (mes = devolucion.mes) and
                   (anyo = devolucion.anyo)) or (mes > devolucion.mes) or
                   (anyo > devolucion.anyo) then
                  textcolor(red);
                if (dia = devolucion.dia) and (mes = devolucion.mes) and
                   (anyo = devolucion.anyo) then
                  textcolor(white);
                if mas = true then
                  begin
                    write(', ', Signatura, '-', Devolucion.Dia, '/',
                          Devolucion.Mes, '/', Devolucion.Anyo);
                  end
                else
                  begin
                    write(Signatura, '-', Devolucion.Dia, '/', Devolucion.Mes,
                          '/', Devolucion.Anyo);
                    mas := true;
                  end;
                normvideo;
              end;
          writeln;
        end;
      writeln;
    end
end;

{********************************************************************}

procedure MostrarSocio(Soc: BBDDSocios);

  {Este procedimiento pide al usuario el numero del socio a mostrar, y lo
   manda al procedimiento mostrar. Para ello solo usa la BBDD.}

var
  car, i: integer;

  {Car: Carnet del usuario a mostrar, i es variable de recorrido}
 
  fallo, hallado: boolean;

  {Variables de control}

begin
  fallo := false;
  hallado := false;
  writeln;
  write('Carnet del socio a consultar: ');
  readln(car);
  for i := 1 to Soc.Limite do
    begin
      if Soc.Elemento[i].Carnet = car then
        begin
          Mostrar(Soc, i);
          hallado := true;
        end;
      if (i = Soc.Limite) and (hallado = false) then
        fallo := true;
    end;
  if not fallo then
    begin
      writeln('Fin de ficha.');
    end
  else
    begin
      writeln('El socio no existe.');
    end;
  readln;
end;

{********************************************************************}

procedure MostrarSocios(Soc: BBDDSocios);

  {Este procedimiento es un llamamiento sucesivo al procedimiento mostrar,
   para, mediante un for, ensear todos los libros disponibles. Para ello
   necesita la BBDD.}

var
  i: integer;

  {Variable de recorrido}

begin
  if Soc.Limite = 0 then
    begin
      writeln('No hay socios dados de alta.');
    end
  else
    begin
      writeln;
      for i := 1 to Soc.Limite do
        begin
          Mostrar(Soc, i);
          if (i mod 6) = 0 then
            readln;
        end;
      writeln('Fin de fichero.');
    end;
  readln;
end;

{********************************************************************}

end.